import { Device, RIIC, Email, _sfc_main as _sfc_main$1, AutoFight, Appearance, DailyMission, Recruit, _sfc_main$1 as _sfc_main$2, _sfc_main$2 as _sfc_main$3, Clue, WeeklyPlan, _sfc_main$3 as _sfc_main$4 } from "./LongTasks.js";
import { Wrench } from "./Wrench.js";
import { createInjectionKey, useTheme, derived, cB, cM, cE, c, defineComponent, h, resolveSlot, NBaseIcon, ErrorIcon, resolveWrappedSlot, useConfig, ref, inject, toRef, useMergedState, computed, formatLength, useThemeClass, onMounted, on, onBeforeUnmount, off, call, _export_sfc, createBlock, openBlock, withCtx, createVNode, unref } from "./index.js";
import { __unplugin_components_3, __unplugin_components_2 } from "./Tabs2.js";
import { NIcon } from "./Icon.js";
import { __unplugin_components_6 } from "./Tooltip.js";
import "./HelpText.js";
import "./index2.js";
import "./use-message.js";
import "./SlickOperatorSelect.js";
import "./Image.js";
import "./utils.js";
import "./use-locale.js";
import "./next-frame-once.js";
import "./download.js";
import "./Checkbox.js";
import "./Add.js";
import "./common.js";
import "./Select.js";
import "./Tag.js";
import "./create.js";
import "./use-compitable.js";
import "./get-slot.js";
import "./Avatar.js";
import "./text.js";
import "./headers.js";
import "./RadioGroup.js";
import "./Alert.js";
import "./Flex.js";
import "./Slider.js";
import "./Table.js";
import "./throttle.js";
Object.assign(Object.assign({}, useTheme.props), {
  left: [Number, String],
  right: [Number, String],
  top: [Number, String],
  bottom: [Number, String],
  shape: {
    type: String,
    default: "circle"
  },
  position: {
    type: String,
    default: "fixed"
  }
});
const floatButtonGroupInjectionKey = createInjectionKey("n-float-button-group");
function self(vars) {
  const {
    popoverColor,
    textColor2,
    buttonColor2Hover,
    buttonColor2Pressed,
    primaryColor,
    primaryColorHover,
    primaryColorPressed,
    borderRadius
  } = vars;
  return {
    color: popoverColor,
    colorHover: buttonColor2Hover,
    colorPressed: buttonColor2Pressed,
    colorPrimary: primaryColor,
    colorPrimaryHover: primaryColorHover,
    colorPrimaryPressed: primaryColorPressed,
    textColor: textColor2,
    boxShadow: "0 2px 8px 0px rgba(0, 0, 0, .16)",
    boxShadowHover: "0 2px 12px 0px rgba(0, 0, 0, .24)",
    boxShadowPressed: "0 2px 12px 0px rgba(0, 0, 0, .24)",
    textColorPrimary: "#fff",
    borderRadiusSquare: borderRadius
  };
}
const themeLight = {
  common: derived,
  self
};
const style = cB("float-button", `
 user-select: none;
 cursor: pointer;
 color: var(--n-text-color);
 background-color: var(--n-color);
 font-size: 18px;
 transition:
 color .3s var(--n-bezier),
 border-color .3s var(--n-bezier),
 box-shadow .3s var(--n-bezier),
 background-color .3s var(--n-bezier);
 box-shadow: var(--n-box-shadow);
 display: flex;
 align-items: stretch;
 box-sizing: border-box;
`, [cM("circle-shape", `
 border-radius: 4096px;
 `), cM("square-shape", `
 border-radius: var(--n-border-radius-square);
 `), cE("fill", `
 position: absolute;
 top: 0;
 right: 0;
 bottom: 0
 left: 0;
 transition: background-color .3s var(--n-bezier);
 border-radius: inherit;
 `), cE("body", `
 position: relative;
 flex-grow: 1;
 display: flex;
 align-items: center;
 justify-content: center;
 transition: transform .3s var(--n-bezier), opacity .3s var(--n-bezier);
 border-radius: inherit;
 flex-direction: column;
 box-sizing: border-box;
 padding: 2px 4px;
 gap: 2px;
 transform: scale(1);
 `, [cE("description", `
 font-size: 12px;
 text-align: center;
 line-height: 14px;
 `)]), c("&:hover", "box-shadow: var(--n-box-shadow-hover);", [c(">", [cE("fill", `
 background-color: var(--n-color-hover);
 `)])]), c("&:active", "box-shadow: var(--n-box-shadow-pressed);", [c(">", [cE("fill", `
 background-color: var(--n-color-pressed);
 `)])]), cM("show-menu", [c(">", [cE("menu", `
 pointer-events: all;
 bottom: 100%;
 opacity: 1;
 `), cE("close", `
 transform: scale(1);
 opacity: 1;
 `), cE("body", `
 transform: scale(0.75);
 opacity: 0;
 `)])]), cE("close", `
 opacity: 0;
 transform: scale(0.75);
 position: absolute;
 top: 0;
 right: 0;
 bottom: 0;
 left: 0;
 display: flex;
 align-items: center;
 justify-content: center;
 transition: transform .3s var(--n-bezier), opacity .3s var(--n-bezier);
 `), cE("menu", `
 position: absolute;
 bottom: calc(100% - 8px);
 display: flex;
 flex-direction: column;
 opacity: 0;
 pointer-events: none;
 transition:
 opacity .3s var(--n-bezier),
 bottom .3s var(--n-bezier); 
 `, [c("> *", `
 margin-bottom: 16px;
 `), cB("float-button", `
 position: relative !important;
 `)])]);
const floatButtonProps = Object.assign(Object.assign({}, useTheme.props), {
  width: {
    type: [Number, String],
    default: 40
  },
  height: {
    type: [Number, String],
    default: 40
  },
  left: [Number, String],
  right: [Number, String],
  top: [Number, String],
  bottom: [Number, String],
  shape: {
    type: String,
    default: "circle"
  },
  position: {
    type: String,
    default: "fixed"
  },
  type: {
    type: String,
    default: "default"
  },
  menuTrigger: String,
  showMenu: {
    type: Boolean,
    default: void 0
  },
  onUpdateShowMenu: {
    type: [Function, Array],
    default: void 0
  },
  "onUpdate:showMenu": {
    type: [Function, Array],
    default: void 0
  }
});
const __unplugin_components_1 = defineComponent({
  name: "FloatButton",
  props: floatButtonProps,
  slots: Object,
  setup(props) {
    const {
      mergedClsPrefixRef,
      inlineThemeDisabled
    } = useConfig(props);
    const selfElRef = ref(null);
    const themeRef = useTheme("FloatButton", "-float-button", style, themeLight, props, mergedClsPrefixRef);
    const floatButtonGroupInjection = inject(floatButtonGroupInjectionKey, null);
    const uncontrolledShowMenuRef = ref(false);
    const controlledShoeMenuRef = toRef(props, "showMenu");
    const mergedShowMenuRef = useMergedState(controlledShoeMenuRef, uncontrolledShowMenuRef);
    function doUpdateShowMenu(value) {
      const {
        onUpdateShowMenu,
        "onUpdate:showMenu": _onUpdateShowMenu
      } = props;
      uncontrolledShowMenuRef.value = value;
      if (onUpdateShowMenu) {
        call(onUpdateShowMenu, value);
      }
      if (_onUpdateShowMenu) {
        call(_onUpdateShowMenu, value);
      }
    }
    const cssVarsRef = computed(() => {
      const {
        self: {
          color,
          textColor,
          boxShadow,
          boxShadowHover,
          boxShadowPressed,
          colorHover,
          colorPrimary,
          colorPrimaryHover,
          textColorPrimary,
          borderRadiusSquare,
          colorPressed,
          colorPrimaryPressed
        },
        common: {
          cubicBezierEaseInOut
        }
      } = themeRef.value;
      const {
        type
      } = props;
      return {
        "--n-bezier": cubicBezierEaseInOut,
        "--n-box-shadow": boxShadow,
        "--n-box-shadow-hover": boxShadowHover,
        "--n-box-shadow-pressed": boxShadowPressed,
        "--n-color": type === "primary" ? colorPrimary : color,
        "--n-text-color": type === "primary" ? textColorPrimary : textColor,
        "--n-color-hover": type === "primary" ? colorPrimaryHover : colorHover,
        "--n-color-pressed": type === "primary" ? colorPrimaryPressed : colorPressed,
        "--n-border-radius-square": borderRadiusSquare
      };
    });
    const inlineStyle = computed(() => {
      const {
        width,
        height
      } = props;
      return Object.assign({
        position: floatButtonGroupInjection ? void 0 : props.position,
        width: formatLength(width),
        minHeight: formatLength(height)
      }, floatButtonGroupInjection ? null : {
        left: formatLength(props.left),
        right: formatLength(props.right),
        top: formatLength(props.top),
        bottom: formatLength(props.bottom)
      });
    });
    const mergedShapeRef = computed(() => {
      return floatButtonGroupInjection ? floatButtonGroupInjection.shapeRef.value : props.shape;
    });
    const Mouseenter = () => {
      if (props.menuTrigger === "hover") {
        doUpdateShowMenu(true);
      }
    };
    const handleMouseleave = () => {
      if (props.menuTrigger === "hover" && mergedShowMenuRef.value) {
        doUpdateShowMenu(false);
      }
    };
    const handleClick = () => {
      if (props.menuTrigger === "click") {
        doUpdateShowMenu(!mergedShowMenuRef.value);
      }
    };
    const themeClassHandle = inlineThemeDisabled ? useThemeClass("float-button", computed(() => props.type[0]), cssVarsRef, props) : void 0;
    onMounted(() => {
      const selfEl = selfElRef.value;
      if (selfEl) {
        on("mousemoveoutside", selfEl, handleMouseleave);
      }
    });
    onBeforeUnmount(() => {
      const selfEl = selfElRef.value;
      if (selfEl) {
        off("mousemoveoutside", selfEl, handleMouseleave);
      }
    });
    return {
      inlineStyle,
      selfElRef,
      cssVars: inlineThemeDisabled ? void 0 : cssVarsRef,
      mergedClsPrefix: mergedClsPrefixRef,
      mergedShape: mergedShapeRef,
      mergedShowMenu: mergedShowMenuRef,
      themeClass: themeClassHandle === null || themeClassHandle === void 0 ? void 0 : themeClassHandle.themeClass,
      onRender: themeClassHandle === null || themeClassHandle === void 0 ? void 0 : themeClassHandle.onRender,
      Mouseenter,
      handleMouseleave,
      handleClick
    };
  },
  render() {
    var _a;
    const {
      mergedClsPrefix,
      cssVars,
      mergedShape,
      type,
      menuTrigger,
      mergedShowMenu,
      themeClass,
      $slots,
      inlineStyle,
      onRender
    } = this;
    onRender === null || onRender === void 0 ? void 0 : onRender();
    return h("div", {
      ref: "selfElRef",
      class: [`${mergedClsPrefix}-float-button`, `${mergedClsPrefix}-float-button--${mergedShape}-shape`, `${mergedClsPrefix}-float-button--${type}-type`, mergedShowMenu && `${mergedClsPrefix}-float-button--show-menu`, themeClass],
      style: [cssVars, inlineStyle],
      onMouseenter: this.Mouseenter,
      onMouseleave: this.handleMouseleave,
      onClick: this.handleClick,
      role: "button"
    }, h("div", {
      class: `${mergedClsPrefix}-float-button__fill`,
      "aria-hidden": true
    }), h("div", {
      class: `${mergedClsPrefix}-float-button__body`
    }, (_a = $slots.default) === null || _a === void 0 ? void 0 : _a.call($slots), resolveWrappedSlot($slots.description, (children) => {
      if (children) {
        return h("div", {
          class: `${mergedClsPrefix}-float-button__description`
        }, children);
      }
      return null;
    })), menuTrigger ? h("div", {
      class: `${mergedClsPrefix}-float-button__close`
    }, h(NBaseIcon, {
      clsPrefix: mergedClsPrefix
    }, {
      default: () => h(ErrorIcon, null)
    })) : null, menuTrigger ? h("div", {
      onClick: (e) => {
        e.stopPropagation();
      },
      "data-float-button-menu": true,
      class: `${mergedClsPrefix}-float-button__menu`
    }, resolveSlot($slots.menu, () => [])) : null);
  }
});
const _sfc_main = {
  __name: "DesktopSettings",
  setup(__props) {
    const tab = ref("device");
    return (_ctx, _cache) => {
      const _component_n_icon = NIcon;
      const _component_n_float_button = __unplugin_components_1;
      const _component_n_tab_pane = __unplugin_components_2;
      const _component_n_tabs = __unplugin_components_3;
      const _component_n_tooltip = __unplugin_components_6;
      return openBlock(), createBlock(_component_n_tooltip, {
        trigger: "click",
        placement: "top",
        raw: "",
        "show-arrow": false
      }, {
        trigger: withCtx(() => [
          createVNode(_component_n_float_button, {
            class: "float-btn",
            type: "primary",
            right: "12px",
            bottom: "12px"
          }, {
            default: withCtx(() => [
              createVNode(_component_n_icon, { component: unref(Wrench) }, null, 8, ["component"])
            ]),
            _: 1
          })
        ]),
        default: withCtx(() => [
          createVNode(_component_n_tabs, {
            placement: "left",
            type: "card",
            value: tab.value,
            "onUpdate:value": _cache[0] || (_cache[0] = ($event) => tab.value = $event),
            class: "tabs"
          }, {
            default: withCtx(() => [
              createVNode(_component_n_tab_pane, {
                name: "device",
                tab: "设备与游戏"
              }, {
                default: withCtx(() => [
                  createVNode(Device)
                ]),
                _: 1
              }),
              createVNode(_component_n_tab_pane, {
                name: "riic",
                tab: "基建设置"
              }, {
                default: withCtx(() => [
                  createVNode(RIIC)
                ]),
                _: 1
              }),
              createVNode(_component_n_tab_pane, {
                name: "email",
                tab: "邮件提醒"
              }, {
                default: withCtx(() => [
                  createVNode(Email)
                ]),
                _: 1
              }),
              createVNode(_component_n_tab_pane, {
                name: "skland",
                tab: "森空岛账号"
              }, {
                default: withCtx(() => [
                  createVNode(_sfc_main$1)
                ]),
                _: 1
              }),
              createVNode(_component_n_tab_pane, {
                name: "auto_fight",
                tab: "自动战斗设置"
              }, {
                default: withCtx(() => [
                  createVNode(AutoFight)
                ]),
                _: 1
              }),
              createVNode(_component_n_tab_pane, {
                name: "appearance",
                tab: "性能设置"
              }, {
                default: withCtx(() => [
                  createVNode(Appearance)
                ]),
                _: 1
              }),
              createVNode(_component_n_tab_pane, {
                name: "daily",
                tab: "每日任务"
              }, {
                default: withCtx(() => [
                  createVNode(DailyMission)
                ]),
                _: 1
              }),
              createVNode(_component_n_tab_pane, {
                name: "recruit",
                tab: "公开招募"
              }, {
                default: withCtx(() => [
                  createVNode(Recruit)
                ]),
                _: 1
              }),
              createVNode(_component_n_tab_pane, {
                name: "depot",
                tab: "仓库物品混合读取"
              }, {
                default: withCtx(() => [
                  createVNode(_sfc_main$2)
                ]),
                _: 1
              }),
              createVNode(_component_n_tab_pane, {
                name: "regular",
                tab: "日常任务"
              }, {
                default: withCtx(() => [
                  createVNode(_sfc_main$3)
                ]),
                _: 1
              }),
              createVNode(_component_n_tab_pane, {
                name: "clue",
                tab: "线索收集与信用"
              }, {
                default: withCtx(() => [
                  createVNode(Clue)
                ]),
                _: 1
              }),
              createVNode(_component_n_tab_pane, {
                name: "weekly",
                tab: "刷理智周计划"
              }, {
                default: withCtx(() => [
                  createVNode(WeeklyPlan)
                ]),
                _: 1
              }),
              createVNode(_component_n_tab_pane, {
                name: "long_task",
                tab: "大型任务"
              }, {
                default: withCtx(() => [
                  createVNode(_sfc_main$4)
                ]),
                _: 1
              })
            ]),
            _: 1
          }, 8, ["value"])
        ]),
        _: 1
      });
    };
  }
};
const DesktopSettings = /* @__PURE__ */ _export_sfc(_sfc_main, [["__scopeId", "data-v-b7d5b6d7"]]);
export {
  DesktopSettings as default
};
